Attribute VB_Name = "modFuncs"
Option Explicit

' Diese Code stammt Florian Rittmeier <florian@activevb.de>
' fr ActiveVb.de
' Es wird keinerlei Haftung oder hnliches bernommen
'
' Und ja, ich wei das ist ein Sprachkauderwelsch mit den Funktionsnamen

' Ganz normale Handles
Dim hFileMapping As Long

' Die Basisadresse der Daten im RAM
Dim FileBaseAddress As Long
' Die Gre des reservierten Speichers
Dim FileMaxLength As Long

' Unser zwischenzeitlich verbogenes Array
Dim MemoryFileArray() As Byte

' Das Backup damit beim Aufrumen alles klappt
Dim SafeArrayBackup As SAFEARRAY1D
Dim ArrayVerbogen As Boolean

Const MAPPINGSIZE As Long = 200
Const MAPPINGNAME As String = "COMMUNICATIONMAPPING"


Public Function Mappen() As Boolean
Dim retval As Long

FileMaxLength = MAPPINGSIZE

' Erstellen des FileMappings.
retval = CreateFileMapping(INVALID_HANDLE_VALUE, ByVal 0, _
            PAGE_READWRITE, 0, FileMaxLength, MAPPINGNAME)
If retval = 0 Then
    Call MsgBox("Das FileMapping konnte nicht erstellt werden.", _
                vbExclamation + vbOKOnly, App.Title)
    Exit Function
Else
    hFileMapping = retval
End If

' An dieser Stelle wird die Datei in den Addressraum
' des Programms geladen.
retval = MapViewOfFile(hFileMapping, FILE_MAP_WRITE, 0, 0, 0)
If retval = 0 Then
    ' Es ist was schiefgegangen.
    ' Vorherige Aktion rckgngig machen
    Call CloseHandle(hFileMapping)
    hFileMapping = 0

    Call MsgBox("Da das FileMapping nicht in den Adressraum" & _
                "geladen werden konnte," & vbNewLine & _
                "wurde das FileMapping abgebrochen.", _
                vbExclamation + vbOKOnly, App.Title)
Else
    FileBaseAddress = retval
    Mappen = True
End If
End Function
Public Function UnMappen() As Boolean
Dim retval As Long

' Zunchst die Daten aus dem Adressraum des eigenen Prozesses entfernen
retval = UnmapViewOfFile(ByVal FileBaseAddress)
If retval = 0 Then
    Call MsgBox("Beim Beenden des FileMappings ist folgender Fehler aufgetreten:" _
                & vbNewLine & GetErrorString(Err.LastDllError), _
                vbExclamation + vbOKOnly, App.Title)
Else
    ' Nachdem die Daten nun weg sind, noch as FileMappingObjekt entfernen
    Call CloseHandle(hFileMapping)
    
    ' Alles auf Null setzen
    hFileMapping = 0
    FileBaseAddress = 0
            
    ' Alles gut gegangen!
    UnMappen = True
End If
End Function
Public Function TextSchreiben(ByVal Text As String) As Boolean
Dim strANSI() As Byte
Text = Text & vbCrLf

' Schaun das wir nicht irgendwo im Speicher umherschreiben werden
If Len(Text) > FileMaxLength Then
    Call MsgBox("Text konnte nicht geschrieben werden," & vbCrLf & _
                "da nicht gengend Speicher reserviert wurde.", _
                vbExclamation + vbOKOnly, App.Title)
    Exit Function
End If

' String ins richtige Format umwandeln
ReDim strANSI(0 To (Len(Text) - 1))
strANSI = StrConv(Text, vbFromUnicode)

' Daten kopieren und einfach mal annehmen, das alles geklappt hat
Call CopyMemory(ByVal FileBaseAddress, strANSI(0), Len(Text))

TextSchreiben = True
End Function
Public Function ArrayVerbiegen() As Boolean
' Diese Funktion stammt zum Groteil aus dem Tutorial
' von Gtz Reinecke

' Da wir keinerlei Fehlerberprfung machen,
' knnen wir auch hier zugeben, dass alles geklappt hat
ArrayVerbiegen = True
ArrayVerbogen = True

' Internes SafeArray zur Manipulation
Dim SafeArray As SAFEARRAY1D
    
' Der Name sagt alles
Dim PointerToPointer As Long
Dim PointerToSafeArray As Long

'Ersten Zeiger ermitteln
PointerToPointer = VarPtrArray(MemoryFileArray)
    
'Zweiten Zeiger auslesen
Call CopyMemory(PointerToSafeArray, _
                ByVal PointerToPointer, 4&)
   
'SafeArray in vorgegebene Strukur kopieren
Call CopyMemory(SafeArray, ByVal PointerToSafeArray, _
                Len(SafeArray))
'SafeArray in Backup kopieren
Call CopyMemory(SafeArrayBackup, ByVal PointerToSafeArray, _
                Len(SafeArrayBackup))
    
' Anzahl der Elemente anpassen
SafeArray.Bounds(0).cElements = FileMaxLength
' Zeiger auf die Daten umbiegen
SafeArray.pvData = FileBaseAddress
    
' SafeArray zurck kopieren
Call CopyMemory(ByVal PointerToSafeArray, SafeArray, _
                Len(SafeArray))
End Function
Public Function ArrayWiederherstellen() As Boolean
' Diese Funktion stammt zum Groteil aus dem Tutorial
' von Gtz Reinecke

' Da wir keinerlei Fehlerberprfung machen,
' knnen wir auch hier zugeben, dass alles geklappt hat
ArrayWiederherstellen = True
ArrayVerbogen = False

' Der Name sagt alles
Dim PointerToPointer As Long
Dim PointerToSafeArray As Long

'Ersten Zeiger ermitteln
PointerToPointer = VarPtrArray(MemoryFileArray)
    
'Zweiten Zeiger auslesen
Call CopyMemory(PointerToSafeArray, _
                ByVal PointerToPointer, 4&)
    
' Backup zurck kopieren
Call CopyMemory(ByVal PointerToSafeArray, SafeArrayBackup, _
                Len(SafeArrayBackup))
End Function
Public Sub Initialisierung()
'Feld dimensionieren
ReDim MemoryFileArray(0 To 1)
End Sub

Public Sub AllesFreigeben()
'Alles rckgngig machen, was wir rckgngig machen mssen
If ArrayVerbogen Then modFuncs.ArrayWiederherstellen
If hFileMapping <> 0 Then modFuncs.UnMappen
End Sub
Public Function TextLesen() As String
Dim data As String
Dim pos As Long

TextLesen = Trim(StrConv(MemoryFileArray, vbUnicode))
pos = InStr(1, TextLesen, vbCrLf, vbBinaryCompare)
If pos > 0 Then
    TextLesen = Left(TextLesen, pos - 1)
Else
    ' Es muss ein Zeilenumbruch zu finden sein,
    ' sonst abbrechen!
    TextLesen = ""
End If

End Function
